Index: django/contrib/admin/media/css/widgets.css
===================================================================
--- django/contrib/admin/media/css/widgets.css	(revisión: 9232)
+++ django/contrib/admin/media/css/widgets.css	(copia de trabajo)
@@ -57,10 +57,12 @@
 .calendarnav { font-size:10px; text-align: center; color:#ccc; margin:0; padding:1px 3px; }
 .calendarnav a:link, #calendarnav a:visited, #calendarnav a:hover { color: #999; }
 .calendar-shortcuts { background:white; font-size:10px; line-height:11px; border-top:1px solid #eee; padding:3px 0 4px; color:#ccc; }
-.calendarbox .calendarnav-previous, .calendarbox .calendarnav-next { display:block; position:absolute; font-weight:bold; font-size:12px; background:#C9DBED url(../img/admin/default-bg.gif) bottom left repeat-x; padding:1px 4px 2px 4px; color:white; }
-.calendarnav-previous:hover, .calendarnav-next:hover { background:#036; }
+.calendarbox .calendarnav-previous, .calendarbox .calendarnav-previous-month, .calendarbox .calendarnav-next, .calendarbox .calendarnav-next-month { display:block; position:absolute; font-weight:bold; font-size:12px; background:#C9DBED url(../img/admin/default-bg.gif) bottom left repeat-x; padding:1px 4px 2px 4px; color:white; }
+.calendarnav-previous:hover, .calendarnav-previous-month:hover, .calendarnav-next:hover, .calendarnav-next-month:hover { background:#036; }
 .calendarnav-previous { top:0; left:0; }
 .calendarnav-next { top:0; right:0; }
+.calendarnav-previous-month { top:0; left:15px;}
+.calendarnav-next-month { top:0; right:15px;}
 .calendar-cancel { margin:0 !important; padding:0; font-size:10px; background:#e1e1e1 url(../img/admin/nav-bg.gif) 0 50% repeat-x;  border-top:1px solid #ddd; }
 .calendar-cancel a { padding:2px; color:#999; }
 ul.timelist, .timelist li { list-style-type:none; margin:0; padding:0; }
@@ -97,4 +99,4 @@
 .editinline-stacked .inline-object { margin-left:210px; background:white; }
 .editinline-stacked .inline-source { float:left; width:200px; background:#f8f8f8;  }
 .editinline-stacked .inline-splitter { float:left; width:9px; background:#f8f8f8 url(../img/admin/inline-splitter-bg.gif) 50% 50% no-repeat; border-right:1px solid #ccc; }
-.editinline-stacked .controls { clear:both; background:#e1e1e1 url(../img/admin/nav-bg.gif) top left repeat-x; padding:3px 4px; font-size:11px; border-top:1px solid #ddd; }
\ No newline at end of file
+.editinline-stacked .controls { clear:both; background:#e1e1e1 url(../img/admin/nav-bg.gif) top left repeat-x; padding:3px 4px; font-size:11px; border-top:1px solid #ddd; }
Index: django/contrib/admin/media/js/admin/DateTimeShortcuts.js
===================================================================
--- django/contrib/admin/media/js/admin/DateTimeShortcuts.js	(revisión: 9232)
+++ django/contrib/admin/media/js/admin/DateTimeShortcuts.js	(copia de trabajo)
@@ -167,11 +167,17 @@
 
         // next-prev links
         var cal_nav = quickElement('div', cal_box, '');
-        var cal_nav_prev = quickElement('a', cal_nav, '<', 'href', 'javascript:DateTimeShortcuts.drawPrev('+num+');');
-        cal_nav_prev.className = 'calendarnav-previous';
-        var cal_nav_next = quickElement('a', cal_nav, '>', 'href', 'javascript:DateTimeShortcuts.drawNext('+num+');');
-        cal_nav_next.className = 'calendarnav-next';
+        var cal_nav_prev = quickElement('a', cal_nav, '‹', 'href', 'javascript:DateTimeShortcuts.drawPrev('+num+');');
+        cal_nav_prev.className = 'calendarnav-previous-month';
+        var cal_nav_next = quickElement('a', cal_nav, '›', 'href', 'javascript:DateTimeShortcuts.drawNext('+num+');');
+        cal_nav_next.className = 'calendarnav-next-month';
 
+        var cal_nav_prev_year = quickElement('a', cal_nav, '«', 'href', 'javascript:DateTimeShortcuts.drawPrevYear('+num+');');
+        cal_nav_prev_year.className = 'calendarnav-previous';
+        var cal_nav_next_year = quickElement('a', cal_nav, '»', 'href', 'javascript:DateTimeShortcuts.drawNextYear('+num+');');
+        cal_nav_next_year.className = 'calendarnav-next';
+
+
         // main box
         var cal_main = quickElement('div', cal_box, '', 'id', DateTimeShortcuts.calendarDivName2 + num);
         cal_main.className = 'calendar';
@@ -229,6 +235,12 @@
     dismissCalendar: function(num) {
         document.getElementById(DateTimeShortcuts.calendarDivName1+num).style.display = 'none';
     },
+    drawPrevYear: function(num) {
+        DateTimeShortcuts.calendars[num].drawPreviousYear();
+    },
+    drawNextYear: function(num) {
+        DateTimeShortcuts.calendars[num].drawNextYear();
+    },
     drawPrev: function(num) {
         DateTimeShortcuts.calendars[num].drawPreviousMonth();
     },