Index: docs/ref/middleware.txt
===================================================================
--- docs/ref/middleware.txt	(revision 11805)
+++ docs/ref/middleware.txt	(working copy)
@@ -1,7 +1,7 @@
 .. _ref-middleware:
 
 =============================
-Built-in middleware reference
+Middleware
 =============================
 
 .. module:: django.middleware
Index: docs/ref/templates/index.txt
===================================================================
--- docs/ref/templates/index.txt	(revision 11805)
+++ docs/ref/templates/index.txt	(working copy)
@@ -1,6 +1,6 @@
 .. _ref-templates-index:
 
-Template reference
+Templates
 ==================
 
 Django's template engine provides a powerful mini-language for defining the
Index: docs/ref/contrib/index.txt
===================================================================
--- docs/ref/contrib/index.txt	(revision 11805)
+++ docs/ref/contrib/index.txt	(working copy)
@@ -1,7 +1,7 @@
 .. _ref-contrib-index:
 
 ============================
-The "django.contrib" add-ons
+Contrib
 ============================
 
 Django aims to follow Python's `"batteries included" philosophy`_. It ships
Index: docs/ref/files/index.txt
===================================================================
--- docs/ref/files/index.txt	(revision 11805)
+++ docs/ref/files/index.txt	(working copy)
@@ -1,6 +1,6 @@
 .. _ref-files-index:
 
-File handling reference
+File handling
 =======================
 
 .. module:: django.core.files
Index: docs/ref/request-response.txt
===================================================================
--- docs/ref/request-response.txt	(revision 11805)
+++ docs/ref/request-response.txt	(working copy)
@@ -298,9 +298,9 @@
           >>> q = q.copy() # to make it mutable
           >>> q.update({'a': '2'})
           >>> q.getlist('a')
-          ['1', '2']
+          [u'1', u'2']
           >>> q['a'] # returns the last
-          ['2']
+          [u'2']
 
 .. method:: QueryDict.items()
 
@@ -309,7 +309,7 @@
 
            >>> q = QueryDict('a=1&a=2&a=3')
            >>> q.items()
-           [('a', '3')]
+           [(u'a', '3')]
 
 .. method:: QueryDict.iteritems()
 
@@ -329,7 +329,7 @@
 
            >>> q = QueryDict('a=1&a=2&a=3')
            >>> q.values()
-           ['3']
+           [u'3']
 
 .. method:: QueryDict.itervalues()
 
@@ -369,7 +369,7 @@
 
          >>> q = QueryDict('a=1&a=2&a=3')
          >>> q.lists()
-         [('a', ['1', '2', '3'])]
+         [(u'a', ['1', '2', '3'])]
 
 .. method:: QueryDict.urlencode()
 
Index: docs/ref/unicode.txt
===================================================================
--- docs/ref/unicode.txt	(revision 11805)
+++ docs/ref/unicode.txt	(working copy)
@@ -1,7 +1,7 @@
 .. _ref-unicode:
 
 ======================
-Unicode data in Django
+Unicode
 ======================
 
 .. versionadded:: 1.0
Index: docs/ref/databases.txt
===================================================================
--- docs/ref/databases.txt	(revision 11805)
+++ docs/ref/databases.txt	(working copy)
@@ -1,7 +1,7 @@
 .. _ref-databases:
 
 ===============================
-Notes about supported databases
+Databases
 ===============================
 
 Django attempts to support as many features as possible on all database
@@ -88,7 +88,7 @@
 Django expects the database to support transactions, referential integrity, and
 Unicode (UTF-8 encoding). Fortunately, MySQL_ has all these features as
 available as far back as 3.23. While it may be possible to use 3.23 or 4.0,
-you'll probably have less trouble if you use 4.1 or 5.0.
+you'll probably have less trouble if you use 4.1, 5.0, or 5.1.
 
 MySQL 4.1
 ---------
@@ -110,6 +110,7 @@
 .. _MySQL: http://www.mysql.com/
 .. _MySQL 4.1: http://dev.mysql.com/doc/refman/4.1/en/index.html
 .. _MySQL 5.0: http://dev.mysql.com/doc/refman/5.0/en/index.html
+.. _MySQL 5.1: http://dev.mysql.com/doc/refman/5.1/en/index.html
 
 Storage engines
 ---------------
@@ -117,15 +118,12 @@
 MySQL has several `storage engines`_ (previously called table types). You can
 change the default storage engine in the server configuration.
 
-The default engine is MyISAM_ [#]_. The main drawback of MyISAM is that it
-doesn't currently support transactions or foreign keys. On the plus side, it's
+The default engine is often MyISAM_ [#]_. The main drawback of MyISAM is that it
+doesn't support transactions or foreign keys. On the plus side, it's
 currently the only engine that supports full-text indexing and searching.
 
 The InnoDB_ engine is fully transactional and supports foreign key references.
 
-The BDB_ engine, like InnoDB, is also fully transactional and supports foreign
-key references. However, its use seems to be deprecated.
-
 `Other storage engines`_, including SolidDB_ and Falcon_, are on the horizon.
 For now, InnoDB is probably your best choice.
 
Index: docs/ref/authbackends.txt
===================================================================
--- docs/ref/authbackends.txt	(revision 11805)
+++ docs/ref/authbackends.txt	(working copy)
@@ -1,14 +1,14 @@
 .. _ref-authentication-backends:
 
 ==========================================
-Built-in authentication backends reference
+Authentication backends
 ==========================================
 
 .. module:: django.contrib.auth.backends
    :synopsis: Django's built-in authentication backend classes.
 
 This document details the authentication backends that come with Django. For
-information on how how to use them and how to write your own authentication
+information on how to use them and how to write your own authentication
 backends, see the :ref:`Other authentication sources section
 <authentication-backends>` of the :ref:`User authentication guide
 <topics-auth>`.
Index: docs/ref/settings.txt
===================================================================
--- docs/ref/settings.txt	(revision 11805)
+++ docs/ref/settings.txt	(working copy)
@@ -1,6 +1,6 @@
 .. _ref-settings:
 
-Available settings
+Settings
 ==================
 
 Here's a full list of all available settings, in alphabetical order, and their
Index: docs/ref/signals.txt
===================================================================
--- docs/ref/signals.txt	(revision 11805)
+++ docs/ref/signals.txt	(working copy)
@@ -1,7 +1,7 @@
 .. _ref-signals:
 
 =========================
-Built-in signal reference
+Signals
 =========================
 
 A list of all the signals that Django sends.